% Lage nye filer
clc; format long;
clf;
clear all
close all
cstring = 'ybgkr';
warning('off', 'signal:psd:PSDisObsolete');
choose = true;
insert_calibrationvalues = true;
insert_stop_fit_curves = true;
insert_start_fit_curves = true;
plots = input('Choose plot: Pressure measurments = 1 , FFT = 2 or both = 3 \n >');

i=1;
count = 1;
for_count = 1;
figurnr = 1;

folderPath='StopStartmeasurements/';
filer = dir([folderPath, '*.dat']);
  for i = 1:numel(filer)
    fil =(filer(i).name);
    content = importdata([folderPath, fil]);
    rawdata = content(1:size(content,1),1:6);
    if i >= 2
        collected_data=[collected_data;rawdata];
    else
       collected_data = rawdata;
    end
  end
  rawdata = collected_data;
for sensor = 1:1:6
    pre_count = 1;
    count = 1;
    for_count = 1;
    if sensor == 1
        FFTfigurnr = 100;
    else
        FFTfigurnr = FFTfigurnr + 100;
    end
for for_count = 1:1:4
    pre_count = for_count + 1;

    if for_count == 1 %Stop gen on
          procedure = 1; timedistribution = 1; generator = 1;
    elseif for_count == 2 %Stop gen off
          procedure = 1; timedistribution = 1; generator = 2;
    elseif for_count == 3 %Start gen off
                      procedure = 2; timedistribution = 1; generator = 2;
    elseif for_count == 4 %Start gen on
                  procedure = 2; timedistribution = 1; generator = 1;
    end
    
    if procedure == 1 %Stop procedure
        if timedistribution == 1 % timedistribution: yes 
             if generator == 2 %generator off
                section_start = 73000;
                section_stop = 94000; 
             else %generator on
                section_start = 30000;
                section_stop = 71500; 
            end
        else % timedistribution: no
        section_start = 30000;
        section_stop = 78000; %80000;
         end
    else  %%Start procedure
        if timedistribution == 1 %timedistribution: yes
            if generator == 2 %generator off
                section_start = 140000;
                section_stop = 161000; 
            else %generator on
                section_start = 162000;
                section_stop = 210000; 
            end
        else %timedistribution: no
        section_start = 145000;
        section_stop = 210000;
        end
    end
    
data_utsnitt = rawdata(section_start:section_stop,1:6);
data = data_utsnitt;
timevalues = section_start:1:section_stop;

for insert_calibrationvalues = true
    % Calibration values sensor inlet:
data(:,1) = -251.70683147 + 125.20071257*data(:,1); % unit: [kPa]
inlet = data(:,1);
    
    % Calibration values sensor draft tube:
data(:,2) = -250.91547257 + 125.18474835.*data(:,2); % unit: [kPa]
drafttube_tank = data(:,2);
   
    % Calibration values sensor draft tube cone 1:
% Y= -100.46454314E+0X^0 + 49.94605480E+0X^1 % 4.0 bar g verst i konus
data(:,3) = -100.41820358 + 49.96688477.*data(:,3); %unit: [kPa]
drafttube_cone1 = data(:,3);

    % Calibration values sensor draft tube cone 2:
data(:,4) = -62.94281179 + 31.34806609.*data(:,4); % unit: [kPa]
drafttube_cone2 = data(:,4);

    % Calibration values sensor vaneless space 1:
data(:,5) = 92.68619459 - 70.72386673.*data(:,5); % unit: [kPa]
vaneless1 = data(:,5);

    % Calibration values sensor vaneless space 2:
data(:,6) = 8.06160398 - 79.61615924.*data(:,6); % unit: [kPa]
vaneless2 = data(:,6);
end

if plots == 1
     plot_pressure = true;
     plot_FFT = false;
     figure(figurnr);
elseif plots == 2
    plot_FFT = true;
    plot_pressure = false;
elseif plots == 3
    figure(figurnr);
    plot_pressure = true;
    plot_FFT = true;
else
      disp('Wrong input')
      break
end
    if procedure == 1 %Stop procedure
        for insert_stop_fit_curves = true
      if sensor == 1   %inlet
          if section_start == 73000 %gen off
               a0 =       88.73 ;% (88.7, 88.76)
               a1 =      -0.174 ;% (-0.3036, -0.04434)
               b1 =     -0.3683 ;% (-0.4183, -0.3183)
               a2 =        1.85 ;% (1.435, 2.265)
               b2 =      0.5061 ;% (-1.058, 2.071)
               a3 =     -0.3264 ;% (-0.4657, -0.1871)
               b3 =    -0.08875 ;% (-0.4446, 0.2671)
               a4 =     -0.1178 ;% (-0.1936, -0.04202)
               b4 =    -0.05232 ;% (-0.255, 0.1504)
               a5 =    -0.04546 ;% (-0.1659, 0.07495)
               b5 =    -0.05916 ;% (-0.1724, 0.05409)
               a6 =      0.1322 ;% (0.0009733, 0.2634)
               b6 =    -0.04437 ;% (-0.3672, 0.2785)
               w =   0.0002775 ;% (0.0002724, 0.0002826)
               x = timevalues;
               trendline = a0 + a1*cos(x*w) + b1*sin(x*w) + a2*cos(2*x*w) + b2*sin(2*x*w) + a3*cos(3*x*w) + b3*sin(3*x*w) + a4*cos(4*x*w) + b4*sin(4*x*w) + a5*cos(5*x*w) + b5*sin(5*x*w) + a6*cos(6*x*w) + b6*sin(6*x*w);
          else % timedistribution: no
       a0 =       238.7 ;% (-545.5, 1023)
       a1 =       190.9 ;% (-1014, 1396)
       b1 =       236.7 ;% (-662, 1135)
       a2 =      -49.45 ;% (-458.1, 359.2)
       b2 =       282.7 ;% (-968.9, 1534)
       a3 =      -185.4 ;% (-454.1, 83.32)
       b3 =       137.7 ;% (-844, 1119)
       a4 =      -154.5 ;% (-634.6, 325.7)
       b4 =      -6.531 ;% (-469.8, 456.7)
       a5 =      -62.76 ;% (-397.4, 271.9)
       b5 =      -48.93 ;% (-141.6, 43.74)
       a6 =      -10.58 ;% (-139, 117.8)
       b6 =      -27.58 ;% (-50.16, -5.004)
       a7 =      0.9195 ;% (-23.34, 25.17)
       b7 =      -6.357 ;% (-21.36, 8.65)
       w =   6.857e-05 ;% (5.883e-05, 7.83e-05)
               x = timevalues;
               trendline = a0 + a1*cos(x*w) + b1*sin(x*w) + a2*cos(2*x*w) + b2*sin(2*x*w) + a3*cos(3*x*w) + b3*sin(3*x*w) + a4*cos(4*x*w) + b4*sin(4*x*w) + a5*cos(5*x*w) + b5*sin(5*x*w) + a6*cos(6*x*w) + b6*sin(6*x*w) + a7*cos(7*x*w) + b7*sin(7*x*w);
           end
   p_i = inlet';
   delta_p = p_i - trendline;
   if plot_pressure == 1;
            plot(timevalues,inlet,'b',timevalues,trendline,'r')
                                        title('Inlet sensor')
                  xlabel('Time [milliseconds]')
  ylabel('Gauge pressure [kPa]')
        figure(figurnr);
        figurnr = figurnr + 1;                
   end
     
    %draft tube
    elseif sensor ==2
            if section_start == 73000 %gen off
       a0 =       450.7 ;% (-2.387e+04, 2.477e+04)
       a1 =      -333.9 ;% (-1.183e+04, 1.116e+04)
       b1 =       771.9 ;% (-5.161e+04, 5.315e+04)
       a2 =      -417.8 ;% (-5.497e+04, 5.413e+04)
       b2 =      -448.2 ;% (-8984, 8088)
       a3 =       334.6 ;% (-3186, 3855)
       b3 =        -115 ;% (-4.317e+04, 4.294e+04)
       a4 =      -15.65 ;% (-2.237e+04, 2.234e+04)
       b4 =       154.2 ;% (-9258, 9566)
       a5 =      -39.99 ;% (-6294, 6214)
       b5 =      -24.39 ;% (-6507, 6458)
       a6 =       6.556 ;% (-661.1, 674.3)
       b6 =      -3.997 ;% (-1632, 1624)
       w =    0.000137 ;% (-0.0003178, 0.0005918)
                x = timevalues;
               trendline = a0 + a1*cos(x*w) + b1*sin(x*w) + a2*cos(2*x*w) + b2*sin(2*x*w) + a3*cos(3*x*w) + b3*sin(3*x*w) + a4*cos(4*x*w) + b4*sin(4*x*w) + a5*cos(5*x*w) + b5*sin(5*x*w) + a6*cos(6*x*w) + b6*sin(6*x*w);
           else %timedistribution: no
       a0 =      -15.24 ;% (-15.56, -14.92)
       a1 =     -0.9783 ;% (-1.23, -0.7269)
       b1 =      0.1428 ;% (-0.3987, 0.6842)
       a2 =      0.4587 ;% (-0.06371, 0.981)
       b2 =     -0.5646 ;% (-1.572, 0.4433)
       a3 =      0.4766 ;% (-0.2004, 1.154)
       b3 =      0.2194 ;% (-0.5697, 1.008)
       a4 =     -0.1813 ;% (-0.5858, 0.2232)
       b4 =      0.1682 ;% (-0.3466, 0.6829)
       w =   8.771e-05 ;% (7.487e-05, 0.0001005)
         x = timevalues;
         trendline = a0 + a1*cos(x*w) + b1*sin(x*w) + a2*cos(2*x*w) + b2*sin(2*x*w) + a3*cos(3*x*w) + b3*sin(3*x*w) + a4*cos(4*x*w) + b4*sin(4*x*w);
           end
   p_i =drafttube_tank';
   delta_p = p_i - trendline;
      if plot_pressure == 1;         
   plot(timevalues,drafttube_tank,'b',timevalues,trendline,'r')
                                           title('Drafttube sensor')
                  xlabel('Time [milliseconds]')
  ylabel('Gauge pressure [kPa]')
        figure(figurnr);
        figurnr = figurnr + 1; 
      end
      
           %draft tube cone1
    elseif sensor ==3
            if section_start == 73000 %gen off
       a0 =      -24.42 ;% (-24.49, -24.36)
       a1 =     -0.3716 ;% (-0.6269, -0.1164)
       b1 =      0.6112 ;% (0.338, 0.8844)
       a2 =      0.1436 ;% (-0.2905, 0.5776)
       b2 =      -0.399 ;% (-0.629, -0.1691)
       a3 =      0.3014 ;% (-0.004212, 0.6071)
       b3 =      0.1756 ;% (-0.2882, 0.6393)
       a4 =     -0.1001 ;% (-0.2734, 0.07328)
       b4 =    -0.08089 ;% (-0.2885, 0.1267)
       w =   0.0002207 ;% (0.0002141, 0.0002273) 
                x = timevalues;
               trendline = a0 + a1*cos(x*w) + b1*sin(x*w) + a2*cos(2*x*w) + b2*sin(2*x*w) + a3*cos(3*x*w) + b3*sin(3*x*w) + a4*cos(4*x*w) + b4*sin(4*x*w);
            elseif section_stop == 71500 % gen on
       a0 =      -24.59 ;% (-24.6, -24.58)
       a1 =     0.01913 ;% (-0.01403, 0.05228)
       b1 =     -0.2376;% (-0.2525, -0.2228)
       a2 =    -0.06338 ;% (-0.08999, -0.03678)
       b2 =      0.1322 ;% (0.1123, 0.152)
       a3 =      0.0721 ;% (0.06377, 0.08043)
       b3 =     0.01984 ;% (-0.0009571, 0.04063)
       a4 =     0.06217 ;% (0.04785, 0.07649)
       b4 =      0.0206 ;% (-0.0109, 0.05211)
       a5 =    -0.09232 ;% (-0.1153, -0.06937)
       b5 =    -0.04084 ;% (-0.1014, 0.01971)
       a6 =     0.05027 ;% (0.03984, 0.0607)
       b6 =    -0.01425 ;% (-0.05757, 0.02907)
       w =   0.0001451 ;% (0.0001429, 0.0001472)
             x = timevalues;
             trendline = a0 + a1*cos(x*w) + b1*sin(x*w) + a2*cos(2*x*w) + b2*sin(2*x*w) + a3*cos(3*x*w) + b3*sin(3*x*w) + a4*cos(4*x*w) + b4*sin(4*x*w) + a5*cos(5*x*w) + b5*sin(5*x*w) + a6*cos(6*x*w) + b6*sin(6*x*w);                    
            else %timedistribution: no
       a0 =      -24.67 ;% (-24.68, -24.67)
       a1 =    -0.03078 ;% (-0.0404, -0.02117)
       b1 =    -0.09806 ;% (-0.1039, -0.09219)
       a2 =     -0.1389 ;% (-0.1479, -0.1298)
       b2 =     0.05961 ;% (0.04442, 0.07481)
       a3 =     0.08399 ;% (0.06698, 0.101)
       b3 =     -0.1884 ;% (-0.2021, -0.1748)
       a4 =    -0.03056 ;% (-0.04758, -0.01354)
       b4 =       0.148 ;% (0.1412, 0.1549)
       a5 =     0.08957 ;% (0.08119, 0.09794)
       b5 =     -0.0117 ;% (-0.02721, 0.003811)
       a6 =     -0.0847 ;% (-0.09928, -0.07011)
       b6 =     0.07232 ;% (0.05503, 0.0896)
       a7 =     0.03705 ;% (0.02648, 0.04761)
       b7 =     0.02415 ;% (0.01375, 0.03454)
       a8 =    -0.09344 ;% (-0.1094, -0.07749)
       b8 =     0.04667 ;% (0.01982, 0.07353)
       w =   0.0001159 ;% (0.0001153, 0.0001166)
             x = timevalues;
             trendline = a0 + a1*cos(x*w) + b1*sin(x*w) + a2*cos(2*x*w) + b2*sin(2*x*w) + a3*cos(3*x*w) + b3*sin(3*x*w) + a4*cos(4*x*w) + b4*sin(4*x*w) + a5*cos(5*x*w) + b5*sin(5*x*w) + a6*cos(6*x*w) + b6*sin(6*x*w) + a7*cos(7*x*w) + b7*sin(7*x*w) + a8*cos(8*x*w) + b8*sin(8*x*w);
           end
         p_i =drafttube_cone1';
   delta_p = p_i - trendline;
      if plot_pressure == 1;        
   plot(timevalues,drafttube_cone1,'b',timevalues,trendline,'r')
                            title('Upper Draft tube cone sensor')
                  xlabel('Time [milliseconds]')
  ylabel('Gauge pressure [kPa]')
        figure(figurnr);
        figurnr = figurnr + 1;                
      end
      
            %draft tube cone2
     elseif sensor ==4
            if section_start == 73000 %gen off
       a0 =      -22.48 ;% (-22.49, -22.48)
       a1 =     0.04053 ;% (-0.06888, 0.1499)
       b1 =      0.2926;%  (0.2775, 0.3078)
       a2 =      0.2474 ;% (0.1437, 0.351)
       b2 =     -0.1266 ;% (-0.3362, 0.08306)
       a3 =     0.03906 ;% (-0.006316, 0.08443)
       b3 =    -0.03934 ;% (-0.09046, 0.01177)
       a4 =    -0.05593 ;% (-0.06831, -0.04355)
       b4 =   -0.006957 ;% (-0.09671, 0.0828)
       a5 =     0.04322 ;% (0.004977, 0.08147)
       b5 =     0.02033 ;% (-0.06653, 0.1072)
       a6 =     -0.0017 ;% (-0.05406, 0.05066)
       b6 =    -0.02253 ;% (-0.02664, -0.01843)
       w =   0.0002948 ;% (0.0002897, 0.0002999)               
                x = timevalues;
               trendline = a0 + a1*cos(x*w) + b1*sin(x*w) + a2*cos(2*x*w) + b2*sin(2*x*w) + a3*cos(3*x*w) + b3*sin(3*x*w) + a4*cos(4*x*w) + b4*sin(4*x*w) + a5*cos(5*x*w) + b5*sin(5*x*w) + a6*cos(6*x*w) + b6*sin(6*x*w);
              elseif section_stop == 71500 % gen on
       a0 =      -22.21 ;% (-22.21, -22.2)
       a1 =      0.2132 ;% (0.1922, 0.2343)
       b1 =      -0.468 ;% (-0.4818, -0.4542)
       a2 =     -0.1315 ;% (-0.1378, -0.1252)
       b2 =     0.04339 ;% (0.03047, 0.0563)
       a3 =     -0.1139 ;% (-0.1292, -0.09864)
       b3 =      0.1016 ;% (0.08725, 0.1159)
       a4 =     0.01798 ;% (0.01028, 0.02568)
       b4 =    -0.01967 ;% (-0.02742, -0.01192)
       a5 =    0.004368 ;% (-0.004273, 0.01301)
       b5 =     0.03364 ;% (0.0281, 0.03918)
       a6 =     0.01189 ;% (0.0004552, 0.02332)
       b6 =     -0.0333 ;% (-0.03921, -0.0274)
       w =   0.0001623 ;% (0.0001614, 0.0001631)
             x = timevalues;
             trendline = a0 + a1*cos(x*w) + b1*sin(x*w) + a2*cos(2*x*w) + b2*sin(2*x*w) + a3*cos(3*x*w) + b3*sin(3*x*w) + a4*cos(4*x*w) + b4*sin(4*x*w) + a5*cos(5*x*w) + b5*sin(5*x*w) + a6*cos(6*x*w) + b6*sin(6*x*w);    
            else     %timedistribution: no    
       a0 =      -22.37 ;% (-22.56, -22.19)
       a1 =     -0.1924 ;% (-0.411, 0.02624)
       b1 =      -0.247 ;% (-0.5745, 0.08054)
       a2 =      0.7446 ;% (0.5366, 0.9526)
       b2 =     -0.4212 ;% (-1.103, 0.2604)
       a3 =       0.303;%  (-0.001442, 0.6075)
       b3 =      0.2528 ;% (-0.008677, 0.5143)
       a4 =     -0.1505 ;% (-0.2756, -0.02538)
       b4 =    -0.01891 ;% (-0.2041, 0.1663)
       a5 =      0.1181 ;% (0.001192, 0.235)
       b5 =    -0.04382 ;% (-0.3354, 0.2478)
       a6 =     0.07374 ;% (0.0358, 0.1117)
       b6 =    -0.03389 ;% (-0.2436, 0.1758)
       w =   8.979e-05 ;% (8.28e-05, 9.678e-05)             
             x = timevalues;
             trendline = a0 + a1*cos(x*w) + b1*sin(x*w) + a2*cos(2*x*w) + b2*sin(2*x*w) + a3*cos(3*x*w) + b3*sin(3*x*w) + a4*cos(4*x*w) + b4*sin(4*x*w) + a5*cos(5*x*w) + b5*sin(5*x*w) + a6*cos(6*x*w) + b6*sin(6*x*w);
            end
   p_i =drafttube_cone2';
   delta_p = p_i - trendline;
      if plot_pressure == 1;         
   plot(timevalues,drafttube_cone2,'b',timevalues,trendline,'r')
                               title('Lower Draft tube cone sensor')
                  xlabel('Time [milliseconds]')
  ylabel('Gauge pressure [kPa]')
        figure(figurnr);
        figurnr = figurnr + 1;   
      end
      
            %vaneless 1
      elseif sensor ==5
            if section_start == 73000 %gen off
       a0 =       98.98 ;% (96.36, 101.6)
       a1 =       26.84 ;% (22.64, 31.05)
       b1 =      -8.437 ;% (-20.88, 4.009)
       a2 =       10.52 ;% (-3.564, 24.61)
       b2 =      -17.09 ;% (-28.35, -5.833)
       a3 =      0.5434 ;% (-22.85, 23.94)
       b3 =      -16.12 ;% (-19.73, -12.5)
       a4 =      -2.671 ;% (-21.1, 15.76)
       b4 =       -8.51 ;% (-12.09, -4.926)
       a5 =      -1.212 ;% (-7.784, 5.361)
       b5 =      -2.243 ;% (-4.976, 0.4909)
       w =   0.0001773 ;% (0.0001703, 0.0001844)
               x = timevalues;
               trendline = a0 + a1*cos(x*w) + b1*sin(x*w) + a2*cos(2*x*w) + b2*sin(2*x*w) + a3*cos(3*x*w) + b3*sin(3*x*w) + a4*cos(4*x*w) + b4*sin(4*x*w) + a5*cos(5*x*w) + b5*sin(5*x*w);
            elseif section_stop == 71500 % gen on
       a0 =       74.52 ;% (-74.31, 223.4)
       a1 =      -83.89 ;% (-343.9, 176.2)
       b1 =      -56.56 ;% (-133.3, 20.23)
       a2 =      -17.12 ;% (-187.5, 153.3)
       b2 =      -66.44 ;% (-197.1, 64.21)
       a3 =       14.93 ;% (-45.35, 75.21)
       b3 =       -31.5 ;% (-146.1, 83.14)
       a4 =       10.51 ;% (7.529, 13.49)
       b4 =      -4.523 ;% (-55.6, 46.55)
       a5 =       1.637 ;% (-3.641, 6.914)
       b5 =      0.5233 ;% (-6.932, 7.978)
       w =   7.224e-05 ;% (5.243e-05, 9.204e-05)
                x = timevalues;
               trendline = a0 + a1*cos(x*w) + b1*sin(x*w) + a2*cos(2*x*w) + b2*sin(2*x*w) + a3*cos(3*x*w) + b3*sin(3*x*w) + a4*cos(4*x*w) + b4*sin(4*x*w) + a5*cos(5*x*w) + b5*sin(5*x*w);
            else %timedistribution: no
       a0 =       232.3 ;% (222.2, 242.5)
       a1 =       42.33 ;% (29.57, 55.09)
       b1 =       184.9 ;% (168.9, 200.8)
       a2 =      -129.8 ;% (-134.7, -124.8)
       b2 =       80.94 ;% (62.78, 99.1)
       a3 =      -79.47 ;% (-92.71, -66.23)
       b3 =      -58.68 ;% (-64.19, -53.17)
       a4 =       8.873 ;% (2.141, 15.6)
       b4 =      -45.88 ;% (-50.12, -41.65)
       a5 =       12.26 ;% (11.91, 12.6)
       b5 =      -4.019 ;% (-6.53, -1.508)
       w =   8.342e-05 ;%  (8.272e-05, 8.412e-05)          
             x = timevalues;
             trendline = a0 + a1*cos(x*w) + b1*sin(x*w) + a2*cos(2*x*w) + b2*sin(2*x*w) + a3*cos(3*x*w) + b3*sin(3*x*w) + a4*cos(4*x*w) + b4*sin(4*x*w) + a5*cos(5*x*w) + b5*sin(5*x*w);
            end
   p_i =vaneless1';
   delta_p = p_i - trendline;
      if plot_pressure == 1;        
   plot(timevalues,vaneless1,'b',timevalues,trendline,'r')
                               title('First vaneless sensor')
                  xlabel('Time [milliseconds]')
  ylabel('Absolute pressure [kPa]')
        figure(figurnr);
        figurnr = figurnr + 1;   
      end
      
        %vaneless 2
    elseif sensor ==6
            if section_start == 73000 %gen off
       a0 =        93.8 ;% (92.18, 95.41)
       a1 =       16.37 ;% (10.58, 22.17)
       b1 =       8.669 ;% (0.5381, 16.8)
       a2 =       11.43 ;% (6.429, 16.42)
       b2 =       3.949 ;% (-7.04, 14.94)
       a3 =       9.186 ;% (-0.6966, 19.07)
       b3 =        5.49;%  (-8.496, 19.48)
       a4 =       3.217 ;% (-9.843, 16.28)
       b4 =       5.477;%  (-0.6808, 11.64)
       a5 =     -0.3439 ;% (-5.839, 5.152)
       b5 =       1.863 ;% (0.2615, 3.464)
       w =   0.0001862 ;% (0.0001785, 0.0001939) 
                x = timevalues;
               trendline = a0 + a1*cos(x*w) + b1*sin(x*w) + a2*cos(2*x*w) + b2*sin(2*x*w) + a3*cos(3*x*w) + b3*sin(3*x*w) + a4*cos(4*x*w) + b4*sin(4*x*w) + a5*cos(5*x*w) + b5*sin(5*x*w);
           elseif section_stop == 71500 %gen on
       a0 =       131.7 ;% (131.6, 131.8)
       a1 =      -3.076 ;% (-3.818, -2.335)
       b1 =       -5.36 ;% (-5.683, -5.036)
       a2 =       1.721 ;% (1.574, 1.868)
       b2 =     -0.4552 ;% (-0.8769, -0.03352)
       a3 =     -0.7948 ;% (-0.8767, -0.7129)
       b3 =      0.2365 ;% (-0.03213, 0.5051)
       a4 =      0.1264 ;% (-0.02359, 0.2765)
       b4 =     -0.2836 ;% (-0.3386, -0.2286)
       w =   0.0001086 ;% (0.0001059, 0.0001113)               
               x = timevalues;
               trendline = a0 + a1*cos(x*w) + b1*sin(x*w) + a2*cos(2*x*w) + b2*sin(2*x*w) + a3*cos(3*x*w) + b3*sin(3*x*w) + a4*cos(4*x*w) + b4*sin(4*x*w);
            else %timedistribution: no
       a0 =       215.3 ;% (206.9, 223.7)
       a1 =        19.7 ;% (10.33, 29.06)
       b1 =       157.6 ;% (143.4, 171.8)
       a2 =      -121.9 ;% (-128.5, -115.4)
       b2 =        48.4 ;% (33.98, 62.82)
       a3 =      -53.29 ;% (-65.45, -41.13)
       b3 =      -67.88 ;% (-69.87, -65.89)
       a4 =       21.64 ;% (17.22, 26.06)
       b4 =      -36.11 ;% (-41.59, -30.63)
       a5 =       11.77 ;% (11.1, 12.45)
       b5 =       1.161 ;% (-1.024, 3.346)
       w =   8.492e-05 ;% (8.423e-05, 8.561e-05) 
             x = timevalues;
             trendline = a0 + a1*cos(x*w) + b1*sin(x*w) + a2*cos(2*x*w) + b2*sin(2*x*w) + a3*cos(3*x*w) + b3*sin(3*x*w) + a4*cos(4*x*w) + b4*sin(4*x*w) + a5*cos(5*x*w) + b5*sin(5*x*w);
            end
   p_i =vaneless2';
   delta_p = p_i - trendline;
               if plot_pressure == 1;
            plot(timevalues,vaneless2,'b',timevalues,trendline,'r')
                                           title('Second vaneless sensor')
                  xlabel('Time [milliseconds]')
  ylabel('Absolute pressure [kPa]')
        figure(figurnr);
        figurnr = figurnr + 1;   
               end
    else
        break;
     end
        end
    elseif procedure ==2 %Start procedure
        for insert_stop_fit_curves = true
            
        if sensor == 1    %inlet
            if section_stop == 161000; % gen off
               trendline =  91.06 - 0.181*cos(timevalues*0.0002944) + 0.5494*sin(timevalues*0.0002944) - 0.06823*cos(2*timevalues*0.0002944) + 1.068*sin(2*timevalues*0.0002944);
            elseif section_start == 162000; %gen on
               a0 =       81.72 ;% (78.89, 84.55)
               a1 =      -10.44 ;% (-13.24, -7.626)
               b1 =       1.544 ;% (-8.923, 12.01)
               a2 =       3.535 ;% (-0.4042, 7.475)
               b2 =      -3.025 ;% (-11.87, 5.822)
               a3 =       1.072 ;% (-6.963, 9.107)
               b3 =        2.94 ;% (2.557, 3.324)
               a4 =      -1.641 ;% (-6.87, 3.588)
               b4 =      -1.263 ;% (-5.769, 3.244)
               a5 =      0.6801 ;% (-0.2296, 1.59)
               b5 =     -0.4295 ;% (-3.437, 2.578)
               a6 =     -0.1904 ;% (-2.532, 2.151)
               b6 =      0.5617 ;% (-0.5282, 1.652)
               w =   5.903e-05 ;%  (5.548e-05, 6.259e-05)
               x = timevalues;
                trendline =  a0 + a1*cos(x*w) + b1*sin(x*w) + a2*cos(2*x*w) + b2*sin(2*x*w) + a3*cos(3*x*w) + b3*sin(3*x*w) + a4*cos(4*x*w) + b4*sin(4*x*w) + a5*cos(5*x*w) + b5*sin(5*x*w) + a6*cos(6*x*w) + b6*sin(6*x*w);
            else % timedistribution = no
                trendline = 80.6 - 4.739*cos(timevalues*5.387*10.^(-5)) + 7.048*sin(timevalues*5.387*10.^(-5)) - 1.428*cos(2*timevalues*5.387*10.^(-5)) - 2.237*sin(2*timevalues*5.387*10.^(-5)) - 0.296*cos(3*timevalues*5.387*10.^(-5)) - 0.6706*sin(3*timevalues*5.387*10.^(-5)) + 0.2559*cos(4*timevalues*5.387*10.^(-5)) + 0.1192*sin(4*timevalues*5.387*10.^(-5)) + 0.08333*cos(5*timevalues*5.387*10.^(-5)) - 0.4539*sin(5*timevalues*5.387*10.^(-5));
            end
   p_i = inlet';
   delta_p = p_i - trendline;
               if plot_pressure == 1;
            plot(timevalues,inlet,'b',timevalues,trendline,'r')
                                                title('Inlet sensor')
                  xlabel('Time [milliseconds]')
          ylabel('Gauge pressure [kPa]')
        figure(figurnr);
        figurnr = figurnr + 1;  
               end
               
            %draft tube
    elseif sensor ==2
            if section_stop == 161000; % gen off
       a1 =      0.3324 ;% (-0.6909, 1.356)
       b1 =   1.465e+05 ;% (1.463e+05, 1.467e+05)
       c1 =        92.8;%  (-246.3, 431.9)
       a2 =      -12.71;%  (-21.96, -3.449)
       b2 =   1.413e+05;%  (1.335e+05, 1.491e+05)
       c2 =        6747;%  (-2771, 1.627e+04)
       a3 =      -2.071;%  (-33.51, 29.37)
       b3 =   1.472e+05;%  (1.424e+05, 1.52e+05)
       c3 =        2804;%  (-6369, 1.198e+04)
       a4 =     -0.0525;%  (-1.941, 1.836)
       b4 =   1.471e+05;%  (1.463e+05, 1.478e+05)
       c4 =       26.66;%  (-1090, 1143)
       a5 =      -11.86;%  (-29.06, 5.332)
       b5 =   1.531e+05 ;% (1.453e+05, 1.608e+05)
       c5 =        5746 ;% (-3.518e+04, 4.667e+04)
       a6 =         -12;%  (-658.6, 634.6)
       b6 =   1.576e+05;%  (1.251e+05, 1.9e+05)
       c6 =        2181;%  (-3.538e+04, 3.974e+04)
       a7 =      -10.08;%  (-33.14, 12.97)
       b7 =   1.613e+05;%  (1.551e+05, 1.676e+05)
       c7 =        1861;%  (-8548, 1.227e+04)
       a8 =       6.635;%  (-737.6, 750.9)
       b8 =   1.571e+05;%  (1.441e+05, 1.701e+05)
       c8 =        1631;%  (-1.665e+04, 1.99
       x = timevalues;
       trendline =  a1*exp(-((x-b1)/c1).^2) + a2*exp(-((x-b2)/c2).^2) + a3*exp(-((x-b3)/c3).^2) + a4*exp(-((x-b4)/c4).^2) + a5*exp(-((x-b5)/c5).^2) + a6*exp(-((x-b6)/c6).^2) + a7*exp(-((x-b7)/c7).^2) + a8*exp(-((x-b8)/c8).^2);         
            else %timedistribution: no
            trendline = -11.11 - 0.3865*cos(timevalues*4.815*10.^(-5)) - 0.8621*sin(timevalues*4.815*10.^(-5)) - 0.2715*cos(2*timevalues*4.815*10.^(-5)) - 0.2011*sin(2*timevalues*4.815*10.^(-5));
            end
   p_i =drafttube_tank';
   delta_p = p_i - trendline;
 
      if plot_pressure == 1;
            plot(timevalues,drafttube_tank,'b',timevalues,trendline,'r')
                                    title('Draft tube tube sensor')
                  xlabel('Time [milliseconds]')
          ylabel('Gauge pressure [kPa]')
        figure(figurnr);
        figurnr = figurnr + 1;  
      end    
      
            %draft tube cone1
    elseif sensor ==3
            if section_stop == 161000; % gen off
       a0 =      -11.74;%  (-11.75, -11.73)
       a1 =     -0.3239 ;% (-0.5724, -0.07531)
       b1 =      -0.338 ;% (-0.5554, -0.1207)
       a2 =    -0.04801 ;% (-0.4629, 0.3669)
       b2 =     -0.2946 ;% (-0.3605, -0.2288)
       a3 =    -0.02483 ;% (-0.2493, 0.1997)
       b3 =     -0.1071 ;% (-0.1639, -0.05036)
       a4 =     0.05698 ;% (-0.1531, 0.2671)
       b4 =    -0.07412 ;% (-0.2295, 0.08123)
       a5 =     -0.0156 ;% (-0.0983, 0.0671)
       b5 =    -0.02242 ;% (-0.07847, 0.03364)
       a6 =     0.02694 ;% (-0.2092, 0.2631)
       b6 =    -0.05584 ;% (-0.1671, 0.0554)
       a7 =    -0.01255 ;% (-0.0343, 0.009205)
       b7 =    0.003962 ;% (-0.05889, 0.06681)
       a8 =     0.03445;%  (-0.169, 0.2379)
       b8 =    -0.03633 ;% (-0.2283, 0.1556)
       w =    0.000272 ;% (0.0002674, 0.0002767)
       x = timevalues;
                trendline = a0 + a1*cos(x*w) + b1*sin(x*w) + a2*cos(2*x*w) + b2*sin(2*x*w) + a3*cos(3*x*w) + b3*sin(3*x*w) + a4*cos(4*x*w) + b4*sin(4*x*w) + a5*cos(5*x*w) + b5*sin(5*x*w) + a6*cos(6*x*w) + b6*sin(6*x*w) + a7*cos(7*x*w) + b7*sin(7*x*w) + a8*cos(8*x*w) + b8*sin(8*x*w);
            elseif section_start == 162000; %gen on
       a0 =       5.156 ;% (-1.811, 12.12)
       a1 =      -12.27 ;% (-16.35, -8.188)
       b1 =       45.85 ;% (31.19, 60.51)
       a2 =      -34.53 ;% (-49.65, -19.41)
       b2 =      -16.83 ;% (-22.66, -11.01)
       a3 =        16.8 ;% (10.86, 22.74)
       b3 =      -24.21 ;% (-38.49, -9.935)
       a4 =       14.69 ;% (2.102, 27.28)
       b4 =       15.01 ;% (10.41, 19.6)
       a5 =      -10.94 ;% (-13.16, -8.714)
       b5 =       6.676 ;% (-2.922, 16.27)
       a6 =      -2.202 ;% (-8.039, 3.635)
       b6 =      -6.151 ;% (-6.732, -5.569)
       a7 =       2.786 ;% (2.554, 3.017)
       b7 =      -0.298 ;% (-3.162, 2.566)
       a8 =     -0.2422 ;% (-1.08, 0.5957)
       b8 =      0.7432 ;% (0.366, 1.12)
       w =   5.558e-05 ;% (5.484e-05, 5.631e-05)
                x = timevalues;
                trendline = a0 + a1*cos(x*w) + b1*sin(x*w) + a2*cos(2*x*w) + b2*sin(2*x*w) + a3*cos(3*x*w) + b3*sin(3*x*w) + a4*cos(4*x*w) + b4*sin(4*x*w) + a5*cos(5*x*w) + b5*sin(5*x*w) + a6*cos(6*x*w) + b6*sin(6*x*w) + a7*cos(7*x*w) + b7*sin(7*x*w) + a8*cos(8*x*w) + b8*sin(8*x*w);              
             else %timedistribution: no
               a0 =      -17.54;%  (-17.58, -17.5)
               a1 =      -3.911;%  (-4.293, -3.53)
               b1 =       3.031;%  (2.489, 3.573)
               a2 =      0.3499;%  (-0.1799, 0.8797)
               b2 =      -2.002;%  (-2.039, -1.965)
               a3 =      0.0562;%  (-0.07887, 0.1913)
               b3 =     -0.1841;%  (-0.2454, -0.1228)
               a4 =       0.581 ;% (0.4042, 0.7579)
               b4 =      0.3194;%  (-0.02155, 0.6603)
               a5 =      -0.186;%  (-0.288, -0.08405)
               b5 =     0.08575;%  (-0.02383, 0.1953)
               a6 =     -0.1624;%  (-0.2035, -0.1213)
               b6 =     0.03538;%  (-0.129, 0.1998)
               a7 =     0.03944;%  (-0.01163, 0.0905)
               b7 =    -0.02474;%  (-0.04334, -0.00615)
               a8 =    -0.02354;%  (-0.1478, 0.1007)
               b8 =       -0.11;%  (-0.1214, -0.09857)
               w =    5.62e-05;%  (5.553e-05, 5.687e-05)
               x = timevalues;
               trendline = a0 + a1*cos(x*w) + b1*sin(x*w) + a2*cos(2*x*w) + b2*sin(2*x*w) + a3*cos(3*x*w) + b3*sin(3*x*w) + a4*cos(4*x*w) + b4*sin(4*x*w) + a5*cos(5*x*w) + b5*sin(5*x*w) + a6*cos(6*x*w) + b6*sin(6*x*w) + a7*cos(7*x*w) + b7*sin(7*x*w) + a8*cos(8*x*w) + b8*sin(8*x*w);          
            end
   p_i =drafttube_cone1';
   delta_p = p_i - trendline;
      if plot_pressure == 1;
            plot(timevalues,drafttube_cone1,'b',timevalues,trendline,'r')
                            title('Upper Draft tube cone sensor')
                  xlabel('Time [milliseconds]')
  
        ylabel('Gauge pressure [kPa]')
        figure(figurnr);
        figurnr = figurnr + 1;                
       % plot(timevalues,delta_p)
      end
      
            %draft tube cone2
     elseif sensor ==4
            if section_stop == 161000; % gen off
                   a0 =      -12.22 ;% (-12.23, -12.21)
                   a1 =     -0.1194 ;% (-0.2878, 0.049)
                   b1 =     -0.4156 ;% (-0.4559, -0.3754)
                   a2 =      0.2507 ;% (0.2071, 0.2943)
                   b2 =     0.05148;%  (-0.1522, 0.2552)
                   a3 =     0.05152;%  (-0.0132, 0.1162)
                   b3 =     0.05365 ;% (-0.01142, 0.1187)
                   a4 =    -0.06494 ;% (-0.06987, -0.06002)
                   b4 =  -0.0004005;%  (-0.105, 0.1042)
                   a5 =    -0.01288;%  (-0.04302, 0.01727)
                   b5 =     0.01476;%  (-0.01351, 0.04304)
                   a6 =    0.007512 ;% (-0.1081, 0.1231)
                   b6 =    -0.04715;%  (-0.06488, -0.02943)
                   a7 =    -0.01763;%  (-0.04757, 0.01232)
                   b7 =    -0.01038 ;% (-0.0611, 0.04033)
                   a8 =     0.02469 ;% (-0.09587, 0.1452)
                   b8 =     0.03745 ;% (-0.04263, 0.1175)
                   w =   0.0002787 ;% (0.000276, 0.0002814)        
                x = timevalues;
                trendline = a0 + a1*cos(x*w) + b1*sin(x*w) + a2*cos(2*x*w) + b2*sin(2*x*w) + a3*cos(3*x*w) + b3*sin(3*x*w) + a4*cos(4*x*w) + b4*sin(4*x*w) + a5*cos(5*x*w) + b5*sin(5*x*w) + a6*cos(6*x*w) + b6*sin(6*x*w) + a7*cos(7*x*w) + b7*sin(7*x*w) + a8*cos(8*x*w) + b8*sin(8*x*w);
            elseif section_start == 162000; %gen on
               a0 =      -17.19 ;%  (-17.19, -17.18)
               a1 =       1.213;%  (1.195, 1.232)
               b1 =       -1.06 ;% (-1.086, -1.034)
               a2 =       0.186 ;% (0.1303, 0.2417)
               b2 =      -1.436 ;% (-1.445, -1.427)
               a3 =     -0.4635 ;% (-0.5187, -0.4083)
               b3 =     -0.9497 ;% (-0.9772, -0.9221)
               a4 =     -0.3963 ;% (-0.4143, -0.3783)
               b4 =     -0.2451 ;% (-0.2759, -0.2143)
               a5 =    -0.02707 ;% (-0.03865, -0.01548)
               b5 =       0.104 ;% (0.101, 0.107)
               a6 =      0.2102 ;% (0.2007, 0.2197)
               b6 =      0.0845 ;% (0.05835, 0.1107)
               a7 =      0.1583 ;% (0.1553, 0.1613)
               b7 =    0.007325 ;% (-0.01422, 0.02887)
               w =   7.204e-05 ;% (7.194e-05, 7.215e-05)             
                x = timevalues;
                trendline = a0 + a1*cos(x*w) + b1*sin(x*w) + a2*cos(2*x*w) + b2*sin(2*x*w) + a3*cos(3*x*w) + b3*sin(3*x*w) + a4*cos(4*x*w) + b4*sin(4*x*w) + a5*cos(5*x*w) + b5*sin(5*x*w) + a6*cos(6*x*w) + b6*sin(6*x*w) + a7*cos(7*x*w) + b7*sin(7*x*w);               
             else %timedistribution: no
                   a0 =      -16.34 ;% (-16.35, -16.33)
                   a1 =      -2.493;%  (-2.625, -2.361)
                   b1 =       1.496 ;% (1.3, 1.692)
                   a2 =      0.8251 ;% (0.5751, 1.075)
                   b2 =      -1.549 ;% (-1.683, -1.414)
                   a3 =    -0.03499;%  (-0.1283, 0.05835)
                   b3 =      0.4103;%  (0.3815, 0.4392)
                   a4 =      0.1419 ;% (0.008545, 0.2753)
                   b4 =      0.4078 ;% (0.3405, 0.4752)
                   a5 =     -0.2276 ;% (-0.3799, -0.07523)
                   b5 =     -0.3747 ;% (-0.4642, -0.2852)
                   a6 =     0.05415 ;% (0.02251, 0.08579)
                   b6 =     0.04903 ;% (0.03834, 0.05972)
                   a7 =     0.08713;%  (0.04198, 0.1323)
                   b7 =     0.08991 ;% (0.0332, 0.1466)
                   a8 =    -0.02848  ;%(-0.08798, 0.03102)
                   b8 =    -0.08004;%  (-0.0911, -0.06897)
                   w =   5.736e-05;%  (5.686e-05, 5.787e-05)
                   x = timevalues;               
                   trendline = a0 + a1*cos(x*w) + b1*sin(x*w) + a2*cos(2*x*w) + b2*sin(2*x*w) + a3*cos(3*x*w) + b3*sin(3*x*w) + a4*cos(4*x*w) + b4*sin(4*x*w) + a5*cos(5*x*w) + b5*sin(5*x*w) + a6*cos(6*x*w) + b6*sin(6*x*w) + a7*cos(7*x*w) + b7*sin(7*x*w) + a8*cos(8*x*w) + b8*sin(8*x*w);          
              end

   p_i =drafttube_cone2';
   delta_p = p_i - trendline;
      if plot_pressure == 1;
             plot(timevalues,drafttube_cone2,'b',timevalues,trendline,'r')
                            title('Lower Draft tube cone sensor')
                  xlabel('Time [milliseconds]')
         ylabel('Gauge pressure [kPa]')
        figure(figurnr);
        figurnr = figurnr + 1;    
      end
      
            %vaneless 1
      elseif sensor ==5


            if section_stop == 161000; % gen off
               a0 =         121;%  (111, 131.1)
               a1 =       20.26;%  (-45.37, 85.89)
               b1 =        24.5;%  (-22.19, 71.19)
               a2 =      -14.15 ;% (-29.68, 1.379)
               b2 =     -0.7216;%  (-75.8, 74.36)
               a3 =       4.135;%  (-69.03, 77.3)
               b3 =      -9.496;%  (-51.1, 32.11)
               a4 =        4.21;%  (-53.33, 61.75)
               b4 =       4.794;%  (-35.58, 45.17)
               a5 =      -4.272 ;% (-30.24, 21.7)
               b5 =       2.413 ;% (-57.14, 61.96)
               a6 =     0.07313 ;% (-42.44, 42.58)
               b6 =       -2.66 ;% (-7.517, 2.197)
               a7 =       1.087 ;% (-0.2846, 2.458)
               b7 =     -0.2058;%  (-19.77, 19.36)
               a8 =     -0.3673;%  (-12.89, 12.15)
               b8 =      0.6405;%  (-7.404, 8.685)
               w =   0.0002014 ;% (0.0001847, 0.0002181)
               x = timevalues;
                trendline = a0 + a1*cos(x*w) + b1*sin(x*w) + a2*cos(2*x*w) + b2*sin(2*x*w) + a3*cos(3*x*w) + b3*sin(3*x*w) + a4*cos(4*x*w) + b4*sin(4*x*w) + a5*cos(5*x*w) + b5*sin(5*x*w) + a6*cos(6*x*w) + b6*sin(6*x*w) + a7*cos(7*x*w) + b7*sin(7*x*w) + a8*cos(8*x*w) + b8*sin(8*x*w);
            elseif section_start == 162000; %gen on
       a0 =         142 ;% (142, 142)
       a1 =      -1.193 ;% (-1.245, -1.142)
       b1 =      0.7633 ;% (0.6664, 0.8602)
       a2 =     0.01228 ;% (-0.05693, 0.08148)
       b2 =      0.4558 ;% (0.4402, 0.4714)
       a3 =        0.69 ;% (0.6287, 0.7512)
       b3 =     -0.3007 ;% (-0.446, -0.1553)
       a4 =      0.3544 ;% (0.1789, 0.5299)
       b4 =     -0.6329 ;% (-0.7382, -0.5275)
       a5 =   -0.006773 ;% (-0.1285, 0.115)
       b5 =     -0.3311 ;% (-0.3471, -0.3152)
       a6 =    -0.09181 ;% (-0.173, -0.01064)
       b6 =      0.1916 ;% (0.1503, 0.233)
       a7 =     0.09251 ;% (-0.04634, 0.2314)
       b7 =      0.2778 ;% (0.232, 0.3235)
       a8 =      0.1397 ;% (0.06248, 0.2169)
       b8 =      0.1325 ;% (0.05166, 0.2134)
       w =   7.121e-05 ;% (7.081e-05, 7.16e-05)                   
                   x = timevalues;               
                   trendline = a0 + a1*cos(x*w) + b1*sin(x*w) + a2*cos(2*x*w) + b2*sin(2*x*w) + a3*cos(3*x*w) + b3*sin(3*x*w) + a4*cos(4*x*w) + b4*sin(4*x*w) + a5*cos(5*x*w) + b5*sin(5*x*w) + a6*cos(6*x*w) + b6*sin(6*x*w) + a7*cos(7*x*w) + b7*sin(7*x*w) + a8*cos(8*x*w) + b8*sin(8*x*w);         
            else %timedistribution: no
       a0 =       136.9 ;% (136.5, 137.3)
       a1 =      -4.318 ;% (-4.96, -3.676)
       b1 =      -10.13 ;% (-10.91, -9.343)
       a2 =       5.259 ;% (3.924, 6.594)
       b2 =      -7.608 ;% (-8.404, -6.811)
       a3 =       7.991;%  (7.736, 8.246)
       b3 =      0.1163;%  (-2.203, 2.436)
       a4 =       2.893;%  (0.7279, 5.059)
       b4 =       4.759;%  (3.822, 5.696)
       a5 =      -1.124;%  (-2.842, 0.5945)
       b5 =       3.262;%  (2.413, 4.111)
       a6 =      -1.935;%  (-2.044, -1.826)
       b6 =      0.3507;%  (-1.054, 1.755)
       a7 =      -0.133;%  (-0.7343, 0.4682)
       b7 =      -0.638;%  (-0.6756, -0.6004)
       w =   5.076e-05;%  (5e-05, 5.152e-05)
       x = timevalues;
       trendline =  a0 + a1*cos(x*w) + b1*sin(x*w) + a2*cos(2*x*w) + b2*sin(2*x*w) + a3*cos(3*x*w) + b3*sin(3*x*w) + a4*cos(4*x*w) + b4*sin(4*x*w) + a5*cos(5*x*w) + b5*sin(5*x*w) + a6*cos(6*x*w) + b6*sin(6*x*w) + a7*cos(7*x*w) + b7*sin(7*x*w);
             end

   p_i =vaneless1';
   delta_p = p_i - trendline;
        if plot_pressure == 1; 
   plot(timevalues,vaneless1,'b',timevalues,trendline,'r')
                                  title('First vaneless sensor')
                  xlabel('Time [milliseconds]')
  ylabel('Absolute pressure [kPa]')
        figure(figurnr);
        figurnr = figurnr + 1;   
        end
    
        %vaneless 2
    elseif sensor ==6
             if section_stop == 161000; % gen off
               a0 =       115.3 ;% (115.2, 115.4)
               a1 =      -1.932 ;% (-7.354, 3.489)
               b1 =       23.53 ;% (22.99, 24.08)
               a2 =      0.5687 ;% (-3.187, 4.325)
               b2 =      -8.178 ;% (-8.45, -7.906)
               a3 =     -0.5277 ;% (-4.678, 3.622)
               b3 =       5.996 ;% (5.652, 6.34)
               a4 =      0.7071 ;% (-1.507, 2.921)
               b4 =      -2.398 ;% (-3.019, -1.777)
               a5 =      0.3406 ;% (-1.533, 2.214)
               b5 =       1.625 ;% (1.215, 2.036)
               a6 =      0.2577 ;% (-1.564, 2.08)
               b6 =      -1.323 ;% (-1.674, -0.9715)
               a7 =    -0.07302 ;% (-0.8944, 0.7484)
               b7 =      0.5135 ;% (0.4044, 0.6225)
               a8 =      0.1609 ;% (-0.636, 0.9578)
               b8 =     -0.4293 ;% (-0.72, -0.1386)
               w =   0.0002504 ;% (0.0002489, 0.000252)              
                x = timevalues;
                trendline = a0 + a1*cos(x*w) + b1*sin(x*w) + a2*cos(2*x*w) + b2*sin(2*x*w) + a3*cos(3*x*w) + b3*sin(3*x*w) + a4*cos(4*x*w) + b4*sin(4*x*w) + a5*cos(5*x*w) + b5*sin(5*x*w) + a6*cos(6*x*w) + b6*sin(6*x*w) + a7*cos(7*x*w) + b7*sin(7*x*w) + a8*cos(8*x*w) + b8*sin(8*x*w);
           elseif section_start == 162000; %gen on
       a0 =       142.2 ;% (140.8, 143.5)
       a1 =       -2.54 ;% (-5.17, 0.08932)
       b1 =      0.1063 ;% (-0.9071, 1.12)
       a2 =       2.225 ;% (0.1134, 4.337)
       b2 =     -0.4409 ;% (-2.21, 1.329)
       a3 =       -2.27 ;% (-3.338, -1.203)
       b3 =      0.9203 ;% (-1.676, 3.517)
       a4 =       2.438 ;% (1.582, 3.293)
       b4 =     -0.4715 ;% (-4.07, 3.127)
       a5 =      -1.653 ;% (-2.87, -0.435)
       b5 =     -0.1313 ;% (-3.163, 2.9)
       a6 =      0.8802 ;% (0.2732, 1.487)
       b6 =     0.02275;%  (-1.925, 1.97)
       a7 =     -0.6059 ;% (-0.8912, -0.3206)
       b7 =    -0.00826 ;% (-1.564, 1.547)
       a8 =       0.243 ;% (-0.191, 0.6769)
       b8 =      0.1232 ;% (-0.5891, 0.8355)
       w =   6.248e-05 ;% (6.054e-05, 6.441e-05)
                   x = timevalues;               
                   trendline = a0 + a1*cos(x*w) + b1*sin(x*w) + a2*cos(2*x*w) + b2*sin(2*x*w) + a3*cos(3*x*w) + b3*sin(3*x*w) + a4*cos(4*x*w) + b4*sin(4*x*w) + a5*cos(5*x*w) + b5*sin(5*x*w) + a6*cos(6*x*w) + b6*sin(6*x*w) + a7*cos(7*x*w) + b7*sin(7*x*w) + a8*cos(8*x*w) + b8*sin(8*x*w);          
            else %timedistribution: no
        a0 =         138;%  (137.4, 138.6)
       a1 =      -1.449 ;% (-2.129, -0.7688)
       b1 =      -6.923 ;% (-7.3, -6.545)
       a2 =       6.502 ;% (6.083, 6.92)
       b2 =      -6.404 ;% (-6.959, -5.849)
       a3 =       9.207 ;% (8.483, 9.931)
       b3 =      0.6067 ;% (-0.9495, 2.163)
       a4 =       4.988 ;% (3.23, 6.745)
       b4 =       5.057;%  (4.046, 6.068)
       a5 =      0.6487 ;% (-1.19, 2.487)
       b5 =       4.837 ;% (4.684, 4.99)
       a6 =      -1.792;%  (-2.701, -0.8839)
       b6 =       2.114;%  (1.136, 3.091)
       a7 =     -0.8117 ;% (-0.9649, -0.6585)
       b7 =     -0.1783 ;% (-0.6379, 0.2812)
       w =   5.005e-05;%  (4.957e-05, 5.053e-05)
       x = timevalues;
       trendline =  a0 + a1*cos(x*w) + b1*sin(x*w) + a2*cos(2*x*w) + b2*sin(2*x*w) + a3*cos(3*x*w) + b3*sin(3*x*w) + a4*cos(4*x*w) + b4*sin(4*x*w) + a5*cos(5*x*w) + b5*sin(5*x*w) + a6*cos(6*x*w) + b6*sin(6*x*w) + a7*cos(7*x*w) + b7*sin(7*x*w);
            end
   p_i =vaneless2';
   delta_p = p_i - trendline;
      if plot_pressure == 1;
            plot(timevalues,vaneless2,'b',timevalues,trendline,'r')
                                           title('Second vaneless sensor')
                  xlabel('Time [milliseconds]')
  ylabel('Absolute pressure [kPa]')
        figure(figurnr);
        figurnr = figurnr + 1;   
      end
    else
        break;
        end
    end
    else
        break
    end
if plot_FFT == 1
    nfft = length(delta_p);
    x_scale = length(delta_p)/2+1;
    for i = 1:x_scale
        i_scale(i)=1;
    end
i_scale = i_scale';

F_sample = 1000;

window = 516*16;
overlap_percent = 66;

weighting_window=hanning(window);                    %   Using the Hann-window
window_overlap = floor(0.01*overlap_percent*window);
norm_factor = ((norm(weighting_window)^2)/(sum(weighting_window)^2));
[pxx_scale,f_scale] = psd(delta_p,nfft,F_sample,weighting_window,window_overlap,'mean');
pxx_norm_scale = pxx_scale*norm_factor;
pxx_norm_scale = sqrt(pxx_norm_scale)*2/sqrt(2);
h = size(data_utsnitt,1)./2+0.5;
f_scale = f_scale(1:h);
i_scale=zeros(size(f_scale));
i_scale=i_scale+count;
pxx_norm_scale = pxx_norm_scale(1:h);
figure(FFTfigurnr); 

plot3(f_scale,i_scale,pxx_norm_scale,cstring(mod(count,5)+1))
    if sensor == 1
        title('Inlet sensor')
    elseif sensor == 2
        title('Draft tube sensor')
    elseif sensor == 3
        title('First Draft tube cone')
    elseif sensor == 4
        title('Second Draft tube cone')
    elseif sensor == 5
        title('First Vaneless sensor')
    elseif sensor == 6
        title('Second Vaneless sensor')
    end
xlabel('Frequency [Hz]')
zlabel('Pressure Amplitude [kPa]')
AZ=11; EL=58;
axis([0 500 1 4]);

grid on;
view(AZ,EL)
    if for_count == 4
        legend('Stop gen on','Stop gen off','Start gen off','Start gen on','Location','NorthEast')
        hold off;
    else
        hold on;
    end
end
count = count + 1;
end
end
warning('on', 'signal:psd:PSDisObsolete');