% Lage nye filer
clc; format long;
clf;
clear all
close all
cstring = 'ybgkrcm';
warning('off', 'signal:psd:PSDisObsolete');
choose = true;
insert_calibrationvalues = true;
state = input('Choose steady state operation: BEP = 1 , Part load = 2 \n >');

i=1;

% Steady state: angle 10,2389 & n_Gen = 319,5845041 rpm
alpha_GV = 10.2389; % Guide vane angle
n_Gen = 319.5845041; % Runner rpm
Z_gv = 28; %Number of guide vanes
Z_rv = 30; %15 whole og 15 split blades
f_n = n_Gen/60 %Runner frequency
f_gv = f_n*Z_gv % Guide vane frequency
f_rv = f_n*Z_rv % Runner vane frequency
f_s_lower = f_n/3.6 %Lower limit Rheingan frequency
f_s_upper = f_n/3.0 %Upper limit Rheingan frequency

if state == 1 
    folderPath='BEP/';
elseif state == 2
    folderPath='Partload/';
else
    disp('Wrong input')
    break
end

filer = dir([folderPath, '*.dat']);
  for i = 1:numel(filer)
    fil =(filer(i).name);
    content = importdata([folderPath, fil]);
    rawdata = content(1:size(content,1),1:6);
    if i >= 2
        collected_data=[collected_data;rawdata];
    else
       collected_data = rawdata;
    end
  end
  rawdata = collected_data;
section_start = 1;
section_stop = 120000;

data = rawdata(section_start:section_stop,1:6);
timevalues = section_start:1:section_stop;

for insert_calibrationvalues = true
    % Calibration values sensor inlet:
data(:,1) = -251.70683147 + 125.20071257*data(:,1); % unit: [kPa]
inlet = data(:,1);
    
    % Calibration values sensor draft tube:
data(:,2) = -250.91547257 + 125.18474835.*data(:,2); % unit: [kPa]
drafttube_tank = data(:,2);
   
    % Calibration values sensor draft tube cone 1:
% Y= -100.46454314E+0X^0 + 49.94605480E+0X^1 % 4.0 bar g verst i konus
data(:,3) = -100.41820358 + 49.96688477.*data(:,3); %unit: [kPa]
drafttube_cone1 = data(:,3);

    % Calibration values sensor draft tube cone 2:
data(:,4) = -62.94281179 + 31.34806609.*data(:,4); % unit: [kPa]
drattube_cone2 = data(:,4);

    % Calibration values sensor vaneless space 1:
data(:,5) = 92.68619459 - 70.72386673.*data(:,5); % unit: [kPa]
vaneless1 = data(:,5);

    % Calibration values sensor vaneless space 2:
data(:,6) = 8.06160398 - 79.61615924.*data(:,6); % unit: [kPa]
vaneless2 = data(:,6);
end
figurnr = 1;
plots = input('Choose plot: Pressure measurments = 1 , FFT = 2 or both = 3 \n >');
     if plots == 1
         plot_pressure = true;
         plot_FFT = false;
         figure(figurnr);
    elseif plots == 2
        plot_FFT = true;
        plot_pressure = false;
    elseif plots == 3
        figure(figurnr);
         plot_pressure = true;
        plot_FFT = true;
    else
      disp('Wrong input')
      break
    end
for sensor = 1:1:6
 if plot_pressure == true
     figure(figurnr);
     figurnr = figurnr + 1;
    if sensor == 1
     delta_p = inlet;
     plot(timevalues,inlet)
            title('Inlet sensor')
               xlabel('Time [milliseconds]')
  ylabel('Gauge pressure [kPa]')
    elseif sensor == 2
        delta_p = drafttube_tank;
        plot(timevalues,drafttube_tank)
              title('Draft tube sensor')
                  xlabel('Time [milliseconds]')
  ylabel('Gauge pressure [kPa]')
    elseif sensor == 3
        delta_p = drafttube_cone1;
        plot(timevalues,drafttube_cone1)
               title('First Draft tube cone sensor')
                  xlabel('Time [milliseconds]')
  ylabel('Gauge pressure [kPa]')
    elseif sensor == 4
        delta_p = drattube_cone2;
        plot(timevalues,drattube_cone2)
               title('Second Draft tube cone sensor')
                xlabel('Time [milliseconds]')
                ylabel('Gauge pressure [kPa]')
    elseif sensor == 5
        delta_p = vaneless1;
        plot(timevalues,vaneless1)
               title('First Vaneless sensor')
                xlabel('Time [milliseconds]')
                ylabel('Absolute pressure [kPa]')
    elseif sensor == 6
        delta_p = vaneless2;
        plot(timevalues,vaneless2)
              title('Second Vaneless sensor')
                xlabel('Time [milliseconds]')
                ylabel('Absolute pressure [kPa]')
    else
        break
    end
 else
    if sensor == 1
     delta_p = inlet;
    elseif sensor == 2
        delta_p = drafttube_tank;
    elseif sensor == 3
        delta_p = drafttube_cone1;
    elseif sensor == 4
        delta_p = drattube_cone2;
    elseif sensor == 5
        delta_p = vaneless1;
    elseif sensor == 6
        delta_p = vaneless2;
    else
        break
    end
 end
 if plot_FFT == true
    nfft = length(delta_p);
    x_scale = length(delta_p)/2+1;
    for i = 1:x_scale
        i_scale(i)=1;
    end
i_scale = i_scale';

F_sample = 1000;

window = 516*16;
overlap_percent = 66;

weighting_window=hanning(window);                    %   Using the Hann-window
window_overlap = floor(0.01*overlap_percent*window);
norm_factor = ((norm(weighting_window)^2)/(sum(weighting_window)^2));
[pxx_scale,f_scale] = psd(delta_p,nfft,F_sample,weighting_window,window_overlap,'mean');
pxx_norm_scale = pxx_scale*norm_factor;
pxx_norm_scale = sqrt(pxx_norm_scale)*2/sqrt(2);
h = size(data,1)./2;
f_scale = f_scale(1:h);
i_scale=zeros(size(f_scale));
i_scale=i_scale+sensor;
pxx_norm_scale = pxx_norm_scale(1:h);
FFTfigurnr = 100;
figure(FFTfigurnr); hold on;
plot3(f_scale,i_scale,pxx_norm_scale,cstring(mod(sensor,7)+1))
if state == 1
    title('BEP operation')
else
   title('Part load operation')
end
xlabel('Frequency [Hz]')
zlabel('Pressure Amplitude [kPa]')
  if sensor == 6
    legend('Inlet','Draft tube','Upper draft tube cone','Lower draft tube cone','Vaneless space 1','Vaneless space 2','Location','NorthEast')
  else
  end
AZ=11; EL=58;
axis([0 500 1 6]);
grid on; 
view(AZ,EL)

f_rel = f_scale/f_n;
FFTfigurnr = 100+FFTfigurnr;
figure(FFTfigurnr); hold on;
plot3(f_rel,i_scale,pxx_norm_scale,cstring(mod(sensor,7)+1))
if state == 1
    title('BEP operation')
else
   title('Part load operation')
end
xlabel('Frequency relative to runner, f/f_n')
zlabel('Pressure Amplitude [kPa]')
%legend('Inlet','Draft tube','Draft tube cone 1','Draft tube cone 2','Vaneless space 1','Vaneless space 2','Location','NorthEast')
AZ=0; EL=0;
axis([0 90 1 6]);
%axis([0 400 1 6]);
grid on; 
view(AZ,EL)
 else
 end
 end
 
warning('on', 'signal:psd:PSDisObsolete');